% C.1.13 HORIZONTAL GRADIENT MAGNITUDE
%
% 17/5/2012
% SAMUEL CHEYNEY
%
% SCRIPT TO CALCULATE HORIZONTAL GRADIENT MAGNITUDE
% INPUTS:
% a=TOTAL FIELD DATASET
% x=X-COORDINATES
% y=Y-COORDINATES
% OUTPUTS:
% abs=HORIZONTAL GRADIENT MAGNITUDE
% xg=X-COORDINATES OF ABS
% yg=Y-COORDINATES OF ABS

close all
clear all

a=load('/data/generate_synthetic/walls/negative/inc90_ht0_2/0_1_by_0_1/walls_neg');

x=0:0.1:10;
y=0:0.1:10;

[hx,hy,abs,xg,yg] = horizontal_gradient_magnitude_func(a,x,y);

plot_grid_imagesc_warn(xg,yg,hx,'dx',999,999,'nT/m','dx.png');
plot_grid_imagesc_warn(xg,yg,hy,'dy',999,999,'nT/m','dy.png');
plot_grid_imagesc_warn(xg,yg,abs,'dh',999,999,'nT/m','dh.png');

save('horiz_grad','abs','-ascii','-double')