
function [hx,hy,abs,xg,yg] = horizontal_gradient_magnitude_func(data,x,y)

% INPUTS
% data = gridded dataset
% x = x coordinates
% y = y coordinates

% OUTPUTS
% hx = gradient in the x-direction
% hy = gradient in the y-direction
% abs = horizontal gradient magnitude
% xg = x-coordinates of gradients
% yg = y-coordinates of gradients

%%%%% CALCULATE Hx %%%%%%

for county=2:(length(y)-1)
    for countx=2:(length(x)-1)
        hx(county-1,countx-1)=(data(county,countx+1)-data(county,countx-1))/(x(countx+1)-x(countx-1));
    end
end

%%%%% CALCULATE Hy %%%%%%

for countx=2:(length(x)-1)
    for county=2:(length(y)-1)
        hy(county-1,countx-1)=(data(county+1,countx)-data(county-1,countx))/(y(county+1)-y(county-1));
    end
end

%%%%% ABSOLUTE HORIZONTAL GRADIENT %%%%%

abs=sqrt(hx.^2+hy.^2);

xg=x(2:length(x)-1);
yg=y(2:length(y)-1);

