% C.1.18 THETA MAP
%
% 17/5/2012
% SAMUEL CHEYNEY
%
% SCRIPT TO CALCULATE THETA MAP
% INPUTS:
% tf=TOTAL FIELD DATASET
% analy=ANALYTIC SIGNAL AMPLITUDE
% x=X-COORDINATES
% y=Y-COORDINATES
% OUTPUTS:
% costheta=THETA MAP

close all
clear all

tf=load('/data/generate_synthetic/depths/inc90_ht0_2/0_1_by_0_1/depths'); % Total field dataset
analy=load('/data/analytic_signal/manual_w_magpick/depths/0_1_by_0_1/noise_none/analytic_signal/noise_none_man_analy'); % Analytic Signal Amplitude

X=0:0.1:20; % x-coordinates
Y=0:0.1:10; % y-coordinates

[hx,hy,abs,xg,yg] = horizontal_gradient_magnitude_func(tf,X,Y);

costheta=abs./analy;

plot_grid_imagesc_warn(X,Y,tf,'Noise None - 0.2m',999,999,'nT','totalfield.png')
plot_grid_imagesc_warn(xg,yg,abs,'Absolute Horizontal Gradient Of Total Field',999,999,'nT/m','totalfield_dxdy.png')
plot_grid_imagesc_warn(xg,yg,analy,'Analytic Signal (Manual Using Magpick)',999,999,'nT/m','totalfield_analytic.png')
plot_grid_imagesc_warn(xg,yg,costheta,'Theta Map',999,999,'cos(theta)','theta_map.png')

save('costheta','costheta','-ascii','-double');
