
function [dx_sym,dy_sym,dz_sym] = fft_deriv_function(a,x,y,req_x,req_y)

% Script to prepare and perform 2D FFT

% a=load('/data/generate_synthetic/remanent/inc64_ht0_2/remanent');

% x=0:0.1:20;
% y=0:0.1:10;

% filename='noise_0_0';
% min_spec=-50;

% plot_grid_imagesc_warn(x,y,a,'Input Data',999,999,'(nT)',[filename,'_input.png'])

% Pad to 128 samples

% req_x=256;
% req_y=256;

size_a=size(a);
len_x=size_a(:,2);
len_y=size_a(:,1);

pad_x1=floor((req_x-len_x)/2);
pad_x2=ceil((req_x-len_x)/2);
pad_y1=floor((req_y-len_y)/2);
pad_y2=ceil((req_y-len_y)/2);

% Pad X

mid_data=NaN(length(y),req_x);

for count=1:len_y
    first_point=a(count,1);
    costap=tukeywin(pad_x1*2,1);
    mid_data(count,[1:pad_x1])=first_point*costap([1:pad_x1]); % Add padded part of X before data

    mid_data(count,[pad_x1+1:len_x+pad_x1])=a(count,:); % Add real data

    last_point=a(count,len_x);
    costap=tukeywin(pad_x2*2,1);
    mid_data(count,[len_x+pad_x1+1:len_x+pad_x1+pad_x2])=last_point*costap([pad_x2+1:pad_x2*2]); % Add padded part of X after data
end

size_mid=size(mid_data);
len_x=size_mid(:,2);
len_y=size_mid(:,1);

% Pad Y

end_count=size(mid_data);

new_data=NaN(req_y,req_x);

for count=1:end_count(:,2)
    first_point=mid_data(1,count);
    costap=tukeywin(pad_y1*2,1);
    new_data([1:pad_y1],count)=first_point*costap([1:pad_y1]); % Add padded part of Y before data
    
    new_data([pad_y1+1:len_y+pad_y1],count)=mid_data(:,count); % Add real data
    
    last_point=mid_data(len_y,count);
    costap=tukeywin(pad_y2*2,1);
    new_data([len_y+pad_y1+1:len_y+pad_y1+pad_y2],count)=last_point*costap([pad_y2+1:pad_y2*2]); % Add padded part of X after data
end

% DC SHIFT

amount=mean(mean(new_data));
dc_shifted=new_data-amount;

size_prepared=size(dc_shifted);
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),dc_shifted,'Prepared Dataset',999,999,'nT',[filename,'_prepared.png'])

% save([filename,'_prepared'],'dc_shifted','-ascii','-double')

% FFT

fft_result=fft2(dc_shifted);
fft_shift=fftshift(fft_result);
fft_display=(abs(fft_shift)/(size_prepared(:,2)*size_prepared(:,1))).^2;

% fft_display=(abs(fft_shift)).^2;

x_max_wavenum=2*pi()/(2*(x(2)-x(1)));
y_max_wavenum=2*pi()/(2*(y(2)-y(1)));

wave_x=(x_max_wavenum*-1):(x_max_wavenum/(req_x/2)):x_max_wavenum-(x_max_wavenum/(req_x/2));
wave_y=(y_max_wavenum*-1):(y_max_wavenum/(req_y/2)):y_max_wavenum-(y_max_wavenum/(req_y/2));

% plot_fft2_pcolor(wave_x,wave_y,log(abs(fft_display)),'FFT',min_spec,0,'Log FFT2',[filename,'_2d_spectrum.png'])

% DY

fft_size=size(fft_result);

filter=wave_y.*sqrt(-1);

for count=1:req_x
    dy_fourier(:,count)=transpose(filter).*fft_shift(:,count);
end

fft_display=(abs(dy_fourier)/(size_prepared(:,2)*size_prepared(:,1))).^2;

% plot_fft2_pcolor(wave_x,wave_y,log(fft_display),'FFT',min_spec,0,'Log FFT2',[filename,'_dy_fourier.png'])

unshift_dy=ifftshift(dy_fourier);
dy=ifft2(unshift_dy);
dy_sym=ifft2(unshift_dy,'symmetric');

% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),real(dy),'dy',999,999,'(nT/m)',[filename,'_dy_real.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),imag(dy),'dy',999,999,'(nT/m)',[filename,'_dy_imag.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),dy_sym,'dy',999,999,'(nT/m)',[filename,'_dy_symmetric.png'])

dy_sym(:,[1:pad_x1])=[];
dy_sym([1:pad_y1],:)=[];
dy_sym=dy_sym(1:size_a(:,1),1:size_a(:,2));

% plot_grid_imagesc_warn(x,y,dy_sym,'dy Post Processed',999,999,'(nT/m)',[filename,'_dy_post_processed.png'])
% save('dy','dy_sym','-ascii','-double')

% DX

clear filter

fft_size=size(fft_result);

filter=wave_x.*sqrt(-1);

for count=1:req_y
    dx_fourier(count,:)=filter.*fft_shift(count,:);
end

fft_display=(abs(dx_fourier)/(size_prepared(:,2)*size_prepared(:,1))).^2;

% plot_fft2_pcolor(wave_x,wave_y,log(fft_display),'FFT',min_spec,0,'Log FFT2',[filename,'_dx_fourier.png'])

unshift_dx=ifftshift(dx_fourier);
dx=ifft2(unshift_dx);
dx_sym=ifft2(unshift_dx,'symmetric');

% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),real(dx),'dx',999,999,'(nT/m)',[filename,'_dx_real.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),imag(dx),'dx',999,999,'(nT/m)',[filename,'_dx_imag.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),dx_sym,'dx',999,999,'(nT/m)',[filename,'_dx_symmetric.png'])

dx_sym(:,[1:pad_x1])=[];
dx_sym([1:pad_y1],:)=[];
dx_sym=dx_sym(1:size_a(:,1),1:size_a(:,2));

% plot_grid_imagesc_warn(x,y,dx_sym,'dx Post Processed',999,999,'(nT/m)',[filename,'_dx_post_processed.png'])
% save('dx','dx_sym','-ascii','-double')

dh=sqrt((dx_sym.^2)+(dy_sym.^2));
% plot_grid_imagesc_warn(x,y,dh,'dh Post Processed',999,999,'(nT/m)',[filename,'_dh_post_processed.png'])
% save('dh','dh','-ascii','-double')

% DZ

clear filter

for county=1:req_y
    for countx=1:req_x
        filter(county,countx)=sqrt(wave_x(countx)^2+wave_y(county)^2);
    end
end

dz_fourier=filter.*fft_shift;
fft_display=(abs(dz_fourier)/(size_prepared(:,2)*size_prepared(:,1))).^2;

% plot_fft2_pcolor(wave_x,wave_y,log(fft_display),'FFT',999,999,'Log FFT2',[filename,'_dz_fourier.png'])

unshift_dz=ifftshift(dz_fourier);
dz=ifft2(unshift_dz);
dz_sym=ifft2(unshift_dz,'symmetric');

% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),real(dz),'dz',999,999,'(nT/m)',[filename,'_dz_real.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),imag(dz),'dz',999,999,'(nT/m)',[filename,'_dz_imag.png'])
% plot_grid_pcolor_prepared(1:size_prepared(:,2),1:size_prepared(:,1),dz_sym,'dz',999,999,'(nT/m)',[filename,'_dz_symmetric.png'])

dz_sym(:,[1:pad_x1])=[];
dz_sym([1:pad_y1],:)=[];
dz_sym=dz_sym(1:size_a(:,1),1:size_a(:,2));

% plot_grid_imagesc_warn(x,y,dz_sym,'dz Post Processed',999,999,'(nT/m)',[filename,'_dz_post_processed.png'])

% save('dz','dz_sym','-ascii','-double')
end

